"""
ChannelReactionTag automatically generated by SDKgen please do not edit this file manually
https://sdkgen.app
"""

import requests
import sdkgen
from requests import RequestException
from typing import List

from .error_exception import ErrorException
from .user import User

class ChannelReactionTag(sdkgen.TagAbstract):
    def __init__(self, http_client: requests.Session, parser: sdkgen.Parser):
        super().__init__(http_client, parser)


    def get_all(self, channel_id: str, message_id: str, emoji: str, type: int, after: str, limit: int) -> List[User]:
        try:
            path_params = {}
            path_params["channel_id"] = channel_id
            path_params["message_id"] = message_id
            path_params["emoji"] = emoji

            query_params = {}
            query_params["type"] = type
            query_params["after"] = after
            query_params["limit"] = limit

            query_struct_names = []

            url = self.parser.url("/channels/:channel_id/messages/:message_id/reactions/:emoji", path_params)

            headers = {}

            response = self.http_client.get(url, headers=headers, params=self.parser.query(query_params, query_struct_names))

            if response.status_code >= 200 and response.status_code < 300:
                return List[User].model_validate_json(json_data=response.content)

            if response.status_code == 400:
                raise ErrorException(response.content)
            if response.status_code == 404:
                raise ErrorException(response.content)
            if response.status_code == 500:
                raise ErrorException(response.content)

            raise sdkgen.UnknownStatusCodeException("The server returned an unknown status code")
        except RequestException as e:
            raise sdkgen.ClientException("An unknown error occurred: " + str(e))

    def delete_all(self, channel_id: str, message_id: str):
        try:
            path_params = {}
            path_params["channel_id"] = channel_id
            path_params["message_id"] = message_id

            query_params = {}

            query_struct_names = []

            url = self.parser.url("/channels/:channel_id/messages/:message_id/reactions", path_params)

            headers = {}

            response = self.http_client.delete(url, headers=headers, params=self.parser.query(query_params, query_struct_names))

            if response.status_code >= 200 and response.status_code < 300:
                return

            if response.status_code == 400:
                raise ErrorException(response.content)
            if response.status_code == 404:
                raise ErrorException(response.content)
            if response.status_code == 500:
                raise ErrorException(response.content)

            raise sdkgen.UnknownStatusCodeException("The server returned an unknown status code")
        except RequestException as e:
            raise sdkgen.ClientException("An unknown error occurred: " + str(e))


